/*
 * Created on 27-Feb-04
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package model;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;

/**
 * @author paquette
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ControlPoint extends Shape {

	/**
	 * @param centerX
	 * @param centerY
	 */
	public ControlPoint(double centerX, double centerY) {
		super(centerX, centerY);
	}

	/* (non-Javadoc)
	 * @see model.Shape#draw(java.awt.Graphics)
	 */
	public void draw(Graphics g) {
		Point center = getCenter();
		int innerWidth = halfWidth - 1;
		g.setColor(Color.black);
		g.fillRect(center.x-halfWidth, center.y-halfWidth, 2*halfWidth, 2*halfWidth);
		g.setColor(Color.white);
		g.fillRect(center.x-innerWidth, center.y-innerWidth, 2*innerWidth, 2*innerWidth);
	}

	public void drawSelectionMarker(Graphics g){
		Point center = getCenter();
		int width = 3;
		int offset = halfWidth + width / 2 + 1;
		int value;
		for (int i=-1; i <= 1; ++i){
			for (int j=-1; j <= 1; ++j){
				if (i == 0 && j == 0) continue;
				value = (i + 1) * 3 + j + 1;
				if (value % 2 ==1) 
					g.setColor(Color.white);
				else
					g.setColor(Color.black);
				g.fillRect(center.x+offset*i - width / 2, 
						   center.y+offset*j - width / 2, width, width);
			}
		}
		
	}
	/* (non-Javadoc)
	 * @see model.Shape#isThisPointIn(java.awt.Point)
	 */
	public boolean isThisPointIn(java.awt.Point aPt) {
		Point center = getCenter();
		int dx = Math.abs(aPt.x - center.x);
		int dy = Math.abs(aPt.y - center.y);
		return dx < SELECTION_THICKNESS && dy <= SELECTION_THICKNESS;
	}
	
	private static int halfWidth = 2;
}
