/*
 * Created on 1-Mar-04
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package model;

import java.awt.Point;
import java.util.List;

/**
 * @author paquette
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PolylineCurveType extends CurveType {

	/* (non-Javadoc)
	 * @see model.CurveType#getNumberOfSegments(int)
	 */
	public int getNumberOfSegments(int numberOfControlPoints) {
		return numberOfControlPoints - 1;
	}

	/* (non-Javadoc)
	 * @see model.CurveType#getNumberOfControlPointsPerSegment()
	 */
	public int getNumberOfControlPointsPerSegment() {
		return 2;
	}

	/* (non-Javadoc)
	 * @see model.CurveType#getControlPoint(int, int)
	 */
	public ControlPoint getControlPoint(List controlPoints, 
	                                    int segmentNumber, int controlPointNumber) {
	    int controlPointIndex = segmentNumber + controlPointNumber;
	    return (ControlPoint)controlPoints.get(controlPointIndex);
	}

	/* (non-Javadoc)
	 * @see model.CurveType#evalCurveAt(java.util.List, int, double)
	 */
	public Point evalCurveAt(List controlPoints, double t) {
		boolean evalMatrix = true;
		if (evalMatrix){
			List tVector = Matrix.buildRowVector2(t, 1);
			List gVector = Matrix.buildColumnVector2(((ControlPoint)controlPoints.get(0)).getCenter(), 
													 ((ControlPoint)controlPoints.get(1)).getCenter()); 
			Point p = Matrix.eval(tVector, linearMatrix, gVector);
		
			return p;
		} else{
			Point c0 = ((ControlPoint)(controlPoints.get(0))).getCenter();
			Point c1 = ((ControlPoint)(controlPoints.get(1))).getCenter();
		
			int x = (int)Math.round(c0.x+t*(c1.x-c0.x));
			int y = (int)Math.round(c0.y+t*(c1.y-c0.y));
			return new Point(x,y);
		}
	}
	
	private List linearMatrix = 
		Matrix.buildMatrix2( -1, 1,
							  1, 0);
}
