/*
 * Created on 1-Mar-04
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package model;

import java.awt.Graphics;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

/**
 * @author paquette
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class ShapeContainer extends Shape implements ShapeObserver {

	/**
	 * @param centerX
	 * @param centerY
	 */
	public ShapeContainer(double centerX, double centerY) {
		super(centerX, centerY);
		shapes = new LinkedList();
	}

	/* (non-Javadoc)
	 * @see model.Shape#draw(java.awt.Graphics)
	 */
	public void draw(Graphics g) {
		Iterator i = shapes.iterator();
		while (i.hasNext()) {
			Shape s = (Shape)i.next();
			s.draw(g);
		}
	}

	public void addShape(Shape s) {
		s.addObserver(this);
		s.setContainer(this);
		shapes.add(s);
	}
	
	public List getShapes() {
		return shapes;
	}

	/* (non-Javadoc)
	 * @see model.ShapeObserver#update()
	 */
	public void update() {
		notifyObservers();
	}
	
	private List shapes;
}
