/*
   This file is part of j2dcg.
   j2dcg is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   j2dcg is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with j2dcg; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package model.curves;

import model.*;
import java.awt.Point;
import java.awt.Graphics;
//import java.awt.*;

/**
 * <p>Title: Point2D</p>
 * <p>Description: A generic 2D Point class.</p>
 * <p>Copyright: Copyright (c) 2004 Colin Barr-Brisebois, ric Paquette</p>
 * <p>Company: ETS - cole de Technologie Suprieure</p>
 * @author unascribed
 * @version $Revision: 1.4 $
 */

/* UNDER DEV */
public class Point2D extends Rectangle {
	public static final int DEFAULT_WIDTH = 10;
	public static final int DEFAULT_HEIGHT = 10;
	public static final Pixel DEFAULT_COLOR = new Pixel(0,0,0,0);
	public static final boolean DEFAULT_VISIBILITY = true; 
	private boolean isVisible;
	
	public Point2D(double centerX, double centerY) {
		super(centerX, centerY, DEFAULT_WIDTH, DEFAULT_HEIGHT, DEFAULT_COLOR);
		this.isVisible = DEFAULT_VISIBILITY;
	}
	
	public Point2D(double centerX, double centerY, int width, int height, Pixel color, boolean isVisible) {
		super(centerX, centerY, width, height, color);
		this.isVisible = isVisible;
	}
	
	public boolean isVisible() {
		return isVisible;
	}
	
	public void setVisible(boolean isVisible) {
		this.isVisible = isVisible;
	}
	
	public void draw(Graphics g) {
		if (isVisible)
			super.draw(g);	
	}
 
	public boolean isThisPointIn(Point aPt) {
		return super.isThisPointIn(aPt);
	}
}
