/*
   This file is part of j2dcg.
   j2dcg is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   j2dcg is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with j2dcg; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package view;

import java.awt.CardLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.JToggleButton;

import controller.Dispatcher;
import controller.TransformersIndex;

//import model.Disc;
//import model.ImageX;
//import model.Rectangle;

/**
 * 
 * <p>Title: ButtonsPanel</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004 Sbastien Bois, Eric Paquette</p>
 * <p>Company: (TS) - cole de Technologie Suprieure</p>
 * @author unascribed
 * @version
 */
// TODO SB Regler le problme de duplication de code et faire des boutons avec des icnes
public class ButtonsPanel extends JPanel 
{
//	private JToggleButton jaddDisc;
//	private JToggleButton jaddRect;
//	private JToggleButton jaddImg;
//	private Vector buttonsList;
	
//	private ToggleButtonsMediator tbMediator;
	private JToggleButton jSelect;
	private JToggleButton jFill;
	private JToggleButton jFilter;
	private JToggleButton jCurves;
	
	private JToggleButton jTranslate;
	private JToggleButton jRotate;
	private JToggleButton jScale;
	private JToggleButton jShear;
	
	
	private TransformersIndex ti;
	private Dispatcher dispatcher;
	
	public ButtonsPanel(Dispatcher d)
	{
		ti = d.getTransformersIndex();
		dispatcher = d;
		
		jSelect  = new JToggleButton("Select", true);
		jFill    = new JToggleButton("Fill");
		jFilter  = new JToggleButton("Filter");
		jCurves  = new JToggleButton("Curves");
		
		jTranslate = new JToggleButton("Translate");
		jScale    = new JToggleButton("Scale");
		jShear    = new JToggleButton("Shear");
		jRotate   = new JToggleButton("Rotation");
		
		// TODO SB Activate translate, scale, shear and rotate toggles buttons when thoses transformations will be ready to use
		ButtonGroup buttonsList = new ButtonGroup();
		//Vector buttonsList = new Vector();
		buttonsList.add(jSelect);
		buttonsList.add(jFill);
		buttonsList.add(jFilter);
		buttonsList.add(jCurves);
//		buttonsList.add(jTranslate);
//		buttonsList.add(jScale);
//		buttonsList.add(jShear);
//		buttonsList.add(jRotate);
		
		// ToggleButtonsMediator tbMediator = new ToggleButtonsMediator(buttonsList);

		// set the layout of this panel
		setLayout(new GridLayout(buttonsList.getButtonCount(),1));
		
		// Transfert the buttons from the vector to the panel and add the ToggleButtonsMediator
		// to each objects in the vector
		/*
		for(int i = 0; i < buttonsList.size(); i++)
		{
			((JToggleButton)buttonsList.get(i)).addActionListener(tbMediator);
			add((JToggleButton)buttonsList.get(i));
		}
		*/
//		TODO SB Activate translate, scale, shear and rotate toggles buttons when thoses transformations will be ready to use
		add(jSelect);
		add(jFill);
		add(jFilter);
		add(jCurves);
//		add(jTranslate);
//		add(jScale);
//		add(jShear);
//		add(jRotate);
				
		jSelect.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JPanel pp = Application.getInstance().parametersPanel;
				CardLayout cl = (CardLayout)pp.getLayout();
				cl.show(pp, "ColorParameterPanel");
				dispatcher.setTheCurrentTransformer(ti.getTheSelector());
				ti.setTheDefaultTransformer(ti.getTheSelector());
			}
		});
				
		jFill.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JPanel pp = Application.getInstance().parametersPanel;
				CardLayout cl = (CardLayout)pp.getLayout();
				cl.show(pp, "FillPanel");
				dispatcher.setTheCurrentTransformer(ti.getTheFiller());
				ti.setTheDefaultTransformer(ti.getTheFiller());
			}
		});
		
		jFilter.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JPanel pp = Application.getInstance().parametersPanel;
				CardLayout cl = (CardLayout)pp.getLayout();
				cl.show(pp, "FilterKernelPanel");
				
				dispatcher.setTheCurrentTransformer(ti.getTheFilter());
				ti.setTheDefaultTransformer(ti.getTheFilter());
			}
		});
		
		jCurves.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JPanel pp = Application.getInstance().parametersPanel;
				CardLayout cl = (CardLayout)pp.getLayout();
				cl.show(pp, "CurvesPanel");
				
				dispatcher.setTheCurrentTransformer(ti.getTheCurves());
				ti.setTheDefaultTransformer(ti.getTheCurves());
			}
		});
		
		jTranslate.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JPanel pp = Application.getInstance().parametersPanel;
				CardLayout cl = (CardLayout)pp.getLayout();
				cl.show(pp, "TranslationTransformation");
				
				dispatcher.setTheCurrentTransformer(ti.getTheTranslation());
				ti.setTheDefaultTransformer(ti.getTheTranslation());
			}
		});
		
		jScale.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JPanel pp = Application.getInstance().parametersPanel;
				CardLayout cl = (CardLayout)pp.getLayout();
				cl.show(pp, "ScallingTransformation");
				
				dispatcher.setTheCurrentTransformer(ti.getTheScale());
				ti.setTheDefaultTransformer(ti.getTheScale());
			}
		});
		
		jShear.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JPanel pp = Application.getInstance().parametersPanel;
				CardLayout cl = (CardLayout)pp.getLayout();
				cl.show(pp, "ShearingTransformation");
				
				dispatcher.setTheCurrentTransformer(ti.getTheShear());
				ti.setTheDefaultTransformer(ti.getTheShear());
			}
		});
		
		jRotate.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JPanel pp = Application.getInstance().parametersPanel;
				CardLayout cl = (CardLayout)pp.getLayout();
				cl.show(pp, "RotationTransformation");
				
				dispatcher.setTheCurrentTransformer(ti.getTheRotation());
				ti.setTheDefaultTransformer(ti.getTheRotation());
			}
		});		
		// jaddDisc = new JToggleButton("Disque");
		// jaddRect = new JToggleButton("Rectangle");		
		// jaddImg  = new JToggleButton("Image");
		//buttonsList.add(jaddDisc);
		//buttonsList.add(jaddRect);
		//buttonsList.add(jaddImg);
		
//		jaddDisc.addActionListener(new ActionListener(){
//			public void actionPerformed(ActionEvent e){
//				Application.getInstance().getActiveDocument().addObject(new Disc(100,60,40));
//			}
//		});
//				
//		jaddRect.addActionListener(new ActionListener(){
//			public void actionPerformed(ActionEvent e){
//				Application.getInstance().getActiveDocument().addObject(new Rectangle(200,200,100,60,0xFFFF0000));
//			}
//		});
//		
//		jaddImg.addActionListener(new ActionListener(){
//			public void actionPerformed(ActionEvent e){
//				JFileChooser chooser = new JFileChooser();
//				chooser.setFileFilter(new ImageX.ImageXExtensionsFilter());
//				chooser.setCurrentDirectory(new File(System.getProperty("user.dir"))); //current folder
//				chooser.setVisible(true);
//				
//				if ((chooser.showOpenDialog(null) != JFileChooser.CANCEL_OPTION) && 
//					(chooser.getSelectedFile().getAbsolutePath() != null)) {
//					Application.getInstance().getActiveDocument().addObject(new ImageX(200,
//																		               200,
//																					   chooser.getSelectedFile().getAbsolutePath()));
//				}
//			}
//		});
	}
}
