/*
 * Created on 13-Jan-04
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 * Log
 * 2004-01-14 EP Corrected a problem in the Mediator initialization.
 */
package view;

import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import javax.swing.AbstractAction;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import model.Pixel;

/**
 * @author paquette
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ColorDialog extends JDialog {
	private JButton okButton;
	private RGBColorMediator rgbMediator;
	private ActionListener okActionListener;
	private ColorDialogResult result;
	
	static public Pixel getColor(Frame owner, double red, double green, double blue, 
	int imageWidths) {
		ColorDialogResult result = new ColorDialogResult();
		ColorDialog colorDialog = new ColorDialog(owner, red, green, blue, imageWidths, result);
		colorDialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		colorDialog.pack();
		colorDialog.setVisible(true);
		if (result.isAccepted()) {
			return result.getPixel();
		} else {
			return null;
		}
	}

	static public Pixel getColor(Frame owner, Pixel color,	int imageWidths) {
		double red = (double)color.getRed() / 255.0;
		double green = (double)color.getGreen() / 255;
		double blue = (double)color.getBlue() / 255;
		return getColor(owner, red, green, blue, imageWidths);
	}
	
	// TODO Ajouter un chantillon de la couleur courrante...
	ColorDialog(Frame owner, double red, double green, double blue, int imageWidths,
	ColorDialogResult result) {
		super(owner, true);
		this.result = result;
		
		JTabbedPane tabbedPane = new JTabbedPane();
		JPanel rgbPanel = createRGBPanel(red, green, blue, imageWidths);
		tabbedPane.addTab("RGB", rgbPanel);

		JPanel cmykPanel = createCMYKPanel(red, green, blue, imageWidths);
		tabbedPane.addTab("CMYK", cmykPanel);
		
		JPanel hlsPanel = createHLSPanel(red, green, blue, imageWidths);
		tabbedPane.addTab("HLS", hlsPanel);
		
		JPanel buttonsPanel = new JPanel();
		buttonsPanel.setLayout(new BoxLayout(buttonsPanel, BoxLayout.X_AXIS));
		AbstractAction okAction = new AbstractAction("OK") {
			public void actionPerformed(ActionEvent e) {
				ColorDialog.this.result.setPixel(getColor());
				ColorDialog.this.result.setAccepted(true);
				dispose();
			}
		};
		okButton = new JButton(okAction);
		buttonsPanel.add(okButton);
		AbstractAction cancelAction = new AbstractAction("Cancel") {
			public void actionPerformed(ActionEvent e) {
				ColorDialog.this.dispose();
			}
		};
		buttonsPanel.add(new JButton(cancelAction));

		JPanel mainPanel = new JPanel();
		mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS));
		mainPanel.add(tabbedPane);
		mainPanel.add(buttonsPanel);

		getContentPane().add(mainPanel, BorderLayout.CENTER);
	}

	private JPanel createRGBPanel(double red, double green, double blue, int imageWidths) {	
		rgbMediator = new RGBColorMediator(red, green, blue, imageWidths, 30);
		
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		ColorSlider csRed = new ColorSlider("R:", red, rgbMediator.getRedImage());
		ColorSlider csGreen = new ColorSlider("G:", green, rgbMediator.getGreenImage());
		ColorSlider csBlue = new ColorSlider("B:", blue, rgbMediator.getBlueImage());
		
		rgbMediator.setRedCS(csRed);
		rgbMediator.setGreenCS(csGreen);
		rgbMediator.setBlueCS(csBlue);
		
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		panel.add(csRed);
		panel.add(csGreen);
		panel.add(csBlue);
		
		return panel;
	}
	
	private JPanel createCMYKPanel(double red, double green, double blue, int imageWidths) {	
		// You will need to modify the rgb mediator such that the changes in color in every tab is
		// reflected in the others too.
		
		JPanel panel = new JPanel();
		
		return panel;
	}
	
	private JPanel createHLSPanel(double red, double green, double blue, int imageWidths) {	
		// You can implement HLS, HSV, or HSB.
		
		JPanel panel = new JPanel();
		
		return panel;
	}
	
	public Pixel getColor() {
		Pixel p = new Pixel();
		p.setRed((int)(rgbMediator.getRed() * 255.0));
		p.setGreen((int)(rgbMediator.getGreen() * 255.0));
		p.setBlue((int)(rgbMediator.getBlue() * 255.0));
		p.setAlpha(255);
		return p;
	}
}

class ColorDialogResult extends Object {
	private Pixel pixel;
	private boolean accepted = false;
	/**
	 * @return
	 */
	public boolean isAccepted() {
		return accepted;
	}

	/**
	 * @return
	 */
	public Pixel getPixel() {
		return pixel;
	}

	/**
	 * @param b
	 */
	public void setAccepted(boolean b) {
		accepted = b;
	}

	/**
	 * @param pixel
	 */
	public void setPixel(Pixel pixel) {
		this.pixel = pixel;
	}
}

class RGBColorMediator extends Object implements SliderObserver {
	ColorSlider redCS;
	ColorSlider greenCS;
	ColorSlider blueCS;
	double red;
	double green;
	double blue;
	BufferedImage redImage;
	BufferedImage greenImage;
	BufferedImage blueImage;
	int imagesWidth;
	int imagesHeight;
	
	RGBColorMediator(double red, double green, double blue, int imagesWidth, int imagesHeight) {
		this.imagesWidth = imagesWidth;
		this.imagesHeight = imagesHeight;
		this.red = red;
		this.green = green;
		this.blue = blue;
		redImage = new BufferedImage(imagesWidth, imagesHeight, BufferedImage.TYPE_INT_ARGB);
		greenImage = new BufferedImage(imagesWidth, imagesHeight, BufferedImage.TYPE_INT_ARGB);
		blueImage = new BufferedImage(imagesWidth, imagesHeight, BufferedImage.TYPE_INT_ARGB);
		computeRedImage(red, green, blue);
		computeGreenImage(red, green, blue);
		computeBlueImage(red, green, blue); 	
	}
	
	
	/*
	 * @see View.SliderObserver#update(double)
	 */
	public void update(ColorSlider s, double v) {
		boolean updateRed = false;
		boolean updateGreen = false;
		boolean updateBlue = false;
		if (s == redCS && v != red) {
			red = v;
			updateGreen = true;
			updateBlue = true;
		}
		if (s == greenCS && v != green) {
			green = v;
			updateRed = true;
			updateBlue = true;
		}
		if (s == blueCS && v != blue) {
			blue = v;
			updateRed = true;
			updateGreen = true;
		}
		if (updateRed) {
			computeRedImage(red, green, blue);
		}
		if (updateGreen) {
			computeGreenImage(red, green, blue);
		}
		if (updateBlue) {
			computeBlueImage(red, green, blue);
		}
	}
	
	public void computeRedImage(double red, double green, double blue) { 
		Pixel p = new Pixel(); 
		p.setGreen((int)(green * 255.0));
		p.setBlue((int)(blue * 255.0));
		p.setAlpha(255);
		for (int i = 0; i<imagesWidth; ++i) {
			p.setRed((int)(((double)i / (double)imagesWidth)*255.0)); 
			int rgb = p.getARGB();
			for (int j = 0; j<imagesHeight; ++j) {
				redImage.setRGB(i, j, rgb);
			}
		}
		if (redCS != null) {
			redCS.update(redImage);
		}
	}
	
	public void computeGreenImage(double red, double green, double blue) {
		Pixel p = new Pixel(); 
		p.setRed((int)(red * 255.0));
		p.setBlue((int)(blue * 255.0));
		p.setAlpha(255);
		for (int i = 0; i<imagesWidth; ++i) {
			p.setGreen((int)(((double)i / (double)imagesWidth)*255.0)); 
			int rgb = p.getARGB();
			for (int j = 0; j<imagesHeight; ++j) {
				greenImage.setRGB(i, j, rgb);
			}
		}
		if (greenCS != null) {
			greenCS.update(greenImage);
		}
	}
	
	public void computeBlueImage(double red, double green, double blue) { 
		Pixel p = new Pixel(); 
		p.setRed((int)(red * 255.0));
		p.setGreen((int)(green * 255.0));
		p.setAlpha(255);
		for (int i = 0; i<imagesWidth; ++i) {
			p.setBlue((int)(((double)i / (double)imagesWidth)*255.0)); 
			int rgb = p.getARGB();
			for (int j = 0; j<imagesHeight; ++j) {
				blueImage.setRGB(i, j, rgb);
			}
		}
		if (blueCS != null) {
			blueCS.update(blueImage);
		}
	}
	
	/**
	 * @return
	 */
	public BufferedImage getBlueImage() {
		return blueImage;
	}

	/**
	 * @return
	 */
	public BufferedImage getGreenImage() {
		return greenImage;
	}

	/**
	 * @return
	 */
	public BufferedImage getRedImage() {
		return redImage;
	}

	/**
	 * @param slider
	 */
	public void setRedCS(ColorSlider slider) {
		redCS = slider;
		slider.addObserver(this);
	}

	/**
	 * @param slider
	 */
	public void setGreenCS(ColorSlider slider) {
		greenCS = slider;
		slider.addObserver(this);
	}

	/**
	 * @param slider
	 */
	public void setBlueCS(ColorSlider slider) {
		blueCS = slider;
		slider.addObserver(this);
	}
	/**
	 * @return
	 */
	public double getBlue() {
		return blue;
	}

	/**
	 * @return
	 */
	public double getGreen() {
		return green;
	}

	/**
	 * @return
	 */
	public double getRed() {
		return red;
	}

}
