/*
 * Created on 14-Jan-04
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
=======
/*
   This file is part of j2dcg.
   j2dcg is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   j2dcg is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with j2dcg; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * <p>Title: ColorParameter</p>
 * <p>Description: Panel with a button controlling the selected object color.</p>
 * <p>Copyright: Copyright (c) 2004 Eric Paquette</p>
 * <p>Company: (TS) - cole de Technologie Suprieure</p>
 * @author Eric Paquette
 * @version $Revision: 1.4 $
>>>>>>> 1.2
 */

package view;

import java.awt.event.ActionEvent;
import java.awt.image.BufferedImage;
import java.util.List;

import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import model.ColoredShapeIF;
import model.DocObserver;
import model.Pixel;
import model.Shape;

/**
 * @author paquette
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ColorParameter extends JPanel implements DocObserver {
	private BufferedImage img;
	private int size = 40;
	private double red = 0;
	private double green = 0;
	private double blue = 0;
	
	ColorParameter() {
		add(new JLabel("Color:"));
		img = new BufferedImage(size, size, BufferedImage.TYPE_INT_RGB);
		computeImage();
		ImageIcon ii = new ImageIcon(img);
		JButton colorButton = new JButton(ii);
		colorButton.addActionListener(
			new AbstractAction() {
				public void actionPerformed(ActionEvent ae) {
					Application app = Application.getInstance();
					Pixel p = ColorDialog.getColor(app, red, green, blue, 150);
					app.colorSelectedObjects(p);
				};
			});
		add(colorButton);
	}
	
	private void computeImage() {
		Pixel p = new Pixel();
		// TODO EP need to add setRed... with double to Pixel.
		p.setRed((int)(red*255.0));
		p.setGreen((int)(green*255.0));
		p.setBlue((int)(blue*255.0));
		p.setAlpha(255);
		int rgb = p.getARGB();
		for (int i = 0; i<size; ++i) {
			for (int j = 0; j<size; ++j) {
				img.setRGB(i, j, rgb);
			}
		}
	}

	/* (non-Javadoc)
	 * @see Model.DocObserver#docChanged()
	 */
	public void docChanged() {
	}

	/* (non-Javadoc)
	 * @see Model.DocObserver#docSelectionChanged()
	 */
	public void docSelectionChanged() {
		List list = Application.getInstance().getActiveDocument().getSelectedObjects();
		// TODO EP If the list is empty, this widget should disapear
		// TODO EP If the list contains many objects, it is not clear which color to show.
		//      But the user should be able to modify the color and this color be affected to all the objects.
		if (list.iterator().hasNext()) {
			Object ColoredShape = null;
			Shape s = (Shape)list.iterator().next();
			if (s instanceof ColoredShapeIF) {
				ColoredShapeIF cs = (ColoredShapeIF)s;
				Pixel pixel = cs.getColor();
				red = (double)pixel.getRed() / 255.0;
				green = (double)pixel.getGreen() / 255;
				blue = (double)pixel.getBlue() / 255;
				computeImage();
				repaint();
			}
		}
	}
}
