/*
   This file is part of j2dcg.
   j2dcg is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   j2dcg is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with j2dcg; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package view;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import model.CurvesModel;
import controller.Curves;
import controller.TransformersIndex;

/**
 * <p>Title: CurvesPanel</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004 Sbastien Bois, Eric Paquette</p>
 * <p>Company: (TS) - cole de Technologie Suprieure</p>
 * @author unascribed
 * @version 
 */
public class CurvesPanel extends JPanel {
	private JLabel curvesLabel;	
	/**
	 * 
	 */
	private JComboBox curvesComboBox;
	/**
	 * 
	 */
	private JLabel sectionsLabel;
	private JTextField sectionsTextField;
	
	private JButton alignedButton
	;
	/**
	 * 
	 */
	private JButton symetricButton;
	/**
	 * 
	 */
	private TransformersIndex ti;
	/**
	 * 
	 * @param ti
	 */
	private Curves curvesTransformer;
	
	public CurvesPanel(TransformersIndex ti) {
		this.ti = ti;
		
		// setLayout(new GridLayout(3, 2));
		setLayout(new FlowLayout());
		
		curvesLabel = new JLabel("Curve type:");
		curvesComboBox = new JComboBox(CurvesModel.CTRL_POINTS_AND_CURVES_VALUES);
		curvesComboBox.addActionListener(
			new ActionListener(){
				public void actionPerformed(ActionEvent ae) {
					CurvesPanel.this.ti.getTheCurves().setCurveType((String)curvesComboBox.getSelectedItem());
				}	
			});
		
		sectionsLabel = new JLabel("Sections:");
		sectionsTextField = new JTextField();
		sectionsTextField.addActionListener(
			new AbstractAction() {
				public void actionPerformed(ActionEvent ae) {
					JTextField tf = (JTextField)ae.getSource();
					int n = Integer.parseInt(tf.getText());
					CurvesPanel.this.ti.getTheCurves().setNumberOfSections(n);
				};
			});

		alignedButton = new JButton("Aligned");
		alignedButton.setToolTipText("Modify control points tangeants such that they are aligned (G1).");
		alignedButton.addActionListener(
			new AbstractAction() {
				public void actionPerformed(ActionEvent ae) {
					CurvesPanel.this.ti.getTheCurves().alignControlPoint();
				};
			});

		symetricButton = new JButton("Symetric");
		symetricButton.setToolTipText("Modify control points tangeants to be symetric (C1).");
		symetricButton.addActionListener(
			new AbstractAction() {
				public void actionPerformed(ActionEvent ae) {
					CurvesPanel.this.ti.getTheCurves().symetricControlPoint();
				};
			});
		
		add(curvesLabel);
		add(curvesComboBox);
		add(sectionsLabel);
		add(sectionsTextField);
		add(alignedButton);
		add(symetricButton);
		
		curvesTransformer = ti.getTheCurves();
		curvesTransformer.setCurvesPanel(this);
	}
	
	/**
	 * @param i
	 */
	public void setNumberOfSections(int i) {
		sectionsTextField.setText(String.valueOf(i));
	}
}
