/*
   This file is part of j2dcg.
   j2dcg is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   j2dcg is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with j2dcg; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package view;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.BorderFactory;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;

import model.KernelModel;
import controller.TransformersIndex;
/**
 * 
 * <p>Title: FilterKernelPanel</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003 Sbastien Bois, Eric Paquette</p>
 * <p>Company: (TS) - cole de Technologie Suprieure</p>
 * @author unascribed
 * @version
 */
public class FilterKernelPanel extends JPanel{
	/**
	 * 
	 */
	private JPanel _setUpPanel;
	/**
	 * 
	 */
	private JPanel _kernelPanel;
	/**
	 * 
	 */
	private JLabel _filterSizeLabel;
	/**
	 * 
	 */
	private JTextField _filterSizeTextField;
	/**
	 * 
	 */	
	private JLabel _kernelCenterLabel;
	/**
	 * 
	 */
	private JComboBox _kernelCenterComboBox;
	/**
	 * 
	 */
	private JLabel _handlingBorderLabel;
	/**
	 * 
	 */ 
	private JComboBox _handlingBorderComboBox;
	/**
	 * 
	 */
	private JLabel _rangeClampLabel;
	/**
	 * 
	 */
	private JComboBox _clampComboBox;
	/**
	 * 
	 */
//	private KernelModel _model;
	/**
	 * 
	 */
	private TransformersIndex ti;
	
	public FilterKernelPanel(TransformersIndex ti){
		_setUpPanel  = new JPanel();
		 
		 this.ti = ti;
		 
		 // TODO SB Set the coordinates of this gridlayout to (5, 2) when adding the functionalities
		_setUpPanel.setLayout(new GridLayout(2, 2));

		_filterSizeLabel 		= new JLabel("Filter Size");
		_filterSizeTextField 	= new JTextField();
		
		// TODO SB Put code to handle on the fly change of kernel size
		// For now, we can only generate 3 x 3 kernel
		_filterSizeTextField.setText(Integer.toString(3));		
		//_model 		 = new KernelModel(3);
		_kernelPanel = new KernelPanel(ti);
		
		_kernelCenterLabel	   = new JLabel("Filter Center");
		// TODO SB For now this ComboBox is not part of the interface
//		_kernelCenterComboBox  = new JComboBox(_model.getCoordinateValues());
		
		_handlingBorderLabel	= new JLabel("Handling Border"); 
		_handlingBorderComboBox	= new JComboBox(KernelModel.HANDLING_BORDER_ARRAY);	
			
		// TODO EP name it range instead of clamp.
		_rangeClampLabel = new JLabel("Range");
		_clampComboBox   = new JComboBox(KernelModel.CLAMP_ARRAY);
		
		// Initialize the combo box to the center of the kernel
		
		// Initialize the Handling Border combo box to the default value of the handling border combo box
		// TODO SB To be redone because I know that the index 0 contains the default value that i want to be used 
		_handlingBorderComboBox.setSelectedIndex(0);
		//_model.setHandlingBorderValue((String)_handlingBorderComboBox.getSelectedItem());
		
		// Initialize the Handling Border combo box to the default value of the handling border combo box
		// TODO SB To be redone because I know that the index 0 contains the default value that i want to be used
		_clampComboBox.setSelectedIndex(0);	
		//_model.setClampValue((String)_clampComboBox.getSelectedItem());
		
		_filterSizeTextField.addKeyListener(
			new KeyListener(){										
				private StringBuffer _buffer = new StringBuffer();
					
				public void keyPressed(KeyEvent ev) {					
				}
				
				public void keyReleased(KeyEvent ev) {
				}
				
				public void keyTyped(KeyEvent ev) {						
				}
			});
/*		
		_kernelCenterComboBox.addActionListener(
			new ActionListener(){
				public void actionPerformed(ActionEvent ae) {
					// TODO SB Activate the listener of this combobox when the comboBox will be add to the interface
					//JComboBox cb = (JComboBox)ae.getSource();
					//_model.setCenter((Coordinates)cb.getSelectedItem());								
				}	
			});
*/		
		_handlingBorderComboBox.addActionListener(
			new ActionListener(){
				public void actionPerformed(ActionEvent ae) {
					//JComboBox cb = (JComboBox)ae.getSource();
					FilterKernelPanel.this.ti.getTheFilter().setBorder((String)_handlingBorderComboBox.getSelectedItem());
				}	
			});
		
		_clampComboBox.addActionListener(
			new ActionListener(){
				public void actionPerformed(ActionEvent ae) {
					JComboBox cb = (JComboBox)ae.getSource();
					FilterKernelPanel.this.ti.getTheFilter().setBorder((String)_clampComboBox.getSelectedItem());
				}	
			});
		
		//
		_filterSizeLabel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
		_kernelCenterLabel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
		_handlingBorderLabel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
		_rangeClampLabel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
		
		// TODO SB Uncomment this code in order to add other set up functionalities
		// TODO SB Don't forget to set the current gridlayout to (5, 2)
		//_setUpPanel.add(_filterSizeLabel);
		//_setUpPanel.add(_filterSizeTextField);
		//_setUpPanel.add(_kernelCenterLabel);
		//_setUpPanel.add(_kernelCenterComboBox);
		_setUpPanel.add(_handlingBorderLabel);
		_setUpPanel.add(_handlingBorderComboBox);
		_setUpPanel.add(_rangeClampLabel);
		_setUpPanel.add(_clampComboBox);
		
		//
		setLayout(new BorderLayout());
		add(_setUpPanel, BorderLayout.NORTH);
		add(_kernelPanel, BorderLayout.CENTER);
	}
}