/*
   This file is part of j2dcg.
   j2dcg is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   j2dcg is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with j2dcg; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package view;
import model.*;
import javax.swing.*;
import java.awt.event.*;
import java.io.*;

/**
 * <p>Title: Menu</p>
 * <p>Description: Class representing the upper menu in the GUI.</p>
 * <p>Copyright: Copyright (c) 2003 **fill me** </p>
 * <p>Company: (TS) - cole de Technologie Suprieure</p>
 * @author unascribed
 * @version $Revision: 1.6 $
 */
public class Menu extends JMenuBar {
  	JMenu addMenu;
  	JMenuItem jAddDisc;
  
  	/**
  	 * Default constructor
  	 */
  	public Menu() {
    	addMenu = new JMenu("Add") ;
    	
    	//*********************************************************************
    	//ca va changer par la suite pour utiliser le prototype
		JMenuItem jAddDisc = new JMenuItem("Disc");
    	jAddDisc.addActionListener(new ActionListener(){
         	public void actionPerformed(ActionEvent e){
        		Application.getInstance().getActiveDocument().addObject(new Disc(100,60,40));
      		}
    	});
		addMenu.add(jAddDisc);
    	
		JMenuItem jAddRect = new JMenuItem("Rectangle");
	    jAddRect.addActionListener(new ActionListener(){
	      	public void actionPerformed(ActionEvent e){
	        	Application.getInstance().getActiveDocument().addObject(new Rectangle(200,200,100,60,0xFFFF0000));
	      	}
	    });
		addMenu.add(jAddRect);
	    
		JMenuItem jAddImg = new JMenuItem("Image");
		jAddImg.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JFileChooser chooser = new JFileChooser();
				chooser.setFileFilter(new ImageX.ImageXExtensionsFilter());
				chooser.setCurrentDirectory(new File(System.getProperty("user.dir"))); //current folder
				chooser.setVisible(true);
				
				if ((chooser.showOpenDialog(null) != JFileChooser.CANCEL_OPTION) && 
					(chooser.getSelectedFile().getAbsolutePath() != null)) {
					Application.getInstance().getActiveDocument().addObject(new ImageX(chooser.getSelectedFile().getAbsolutePath()));
				}
			}
		});
		addMenu.add(jAddImg);
	    
		//*********************************************************************
    
    	add(addMenu);
  	}
}